# -------------------------------
# Day 24, Opening Exercise
# -------------------------------

from random import randint

def get_move_for(token, board):
    # pass in board so that we can validate the move entered
    if token == 'o':
        # human player
        move_str = input('Enter move for ' + token + ': ')
        x, y = move_str.split(' ')
        return int(x), int(y)
    else:
        # computer player
        moves = legal_moves(board)
        pos   = randint( 0, len(moves)-1 )
        x, y  = moves[pos]                            # can return this
        print('Random move for ' + token + ':', x, y) # but added this
        return x, y

# -------------------------------
# TEST DATA AND CASES
# -------------------------------

board_1 = [ [' ', ' ', 'x'],  \
            ['o', ' ', 'x'],  \
            [' ', ' ', 'o'] ]

board_2 = [ [' ', ' ', 'x'],  \
            ['o', 'o', 'x'],  \
            [' ', ' ', 'x'] ]

board_3 = [ ['o', ' ', 'x'],  \
            ['x', 'o', 'x'],  \
            [' ', ' ', 'o'] ]

board_4 = [ ['o', ' ', 'x'],  \
            ['x', 'x', 'x'],  \
            [' ', 'o', 'o'] ]
