from random import randint

MIN_VALUE =  0
MAX_VALUE = 99
LIST_SIZE = 1000000

def generate_empty_buckets():
    bucket_list = []
    for i in range(10):
        bucket_list.append([])
    return bucket_list

def generate_random_list(list_size):
    result = []
    for i in range(list_size):
        next_value = randint(MIN_VALUE, MAX_VALUE)
        result.append( next_value )
    return result

def experiment():
    test_list = generate_random_list(LIST_SIZE)
    buckets = generate_empty_buckets()

    for n in test_list:
        first_digit = n // 10              # or %
        buckets[first_digit].append( n )

    max_size = -1
    min_size = LIST_SIZE + 1
    for bucket in buckets:
        if len(bucket) > max_size:
            max_size = len(bucket)
        if len(bucket) < min_size:
            min_size = len(bucket)

    print("expected bucket size =", int(LIST_SIZE/10))
    print("smallest bucket size =", min_size)
    print("largest  bucket size =", max_size)
