# -------------------------------
# Lab 12, Step 1
# -------------------------------

def display(board):
    for row in board:
        print(row)

# -------------------------------
# Lab 12, Step 2
# -------------------------------

def is_occupied(board, row, col):
    return board[row][col] != ' '

# -------------------------------
# Lab 12, Step 3
# -------------------------------

def make_move(token, board, row, col):
    if is_occupied(board, row, col):
        return False
    board[row][col] = token
    return board

# -------------------------------
# Lab 12, Step 4
# -------------------------------

def is_a_win_for(token, board):
    for i in range(3):
        if is_win_on_row(i, token, board) \
        or is_win_on_col(i, token, board):
            return True
    if is_win_on_diagonal(token, board):
        return True
    return False

def is_win_on_row(row, token, board):
    for item in board[row]:
        if item != token:
            return False
    return True

def is_win_on_col(col, token, board):
    for row in range(3):
        if board[row][col] != token:
            return False
    return True

def is_win_on_diagonal(token, board):
    return (board[0][0] == board[1][1] == board[2][2] == token) \
        or (board[0][2] == board[1][1] == board[2][0] == token)

# -------------------------------
# Lab 12, Step 5
# -------------------------------

def play():
    board     = make_board()
    num_moves = 0
    on_move   = 'x'
    while True:
        num_moves += 1
        row, col = get_move_for(on_move, board)
        make_move(on_move, board, row, col)
        display(board)
        if is_a_win_for(on_move, board):
            print(on_move + ' wins')
            break
        if num_moves == 9:
            print('The game is a draw')
            break
        on_move = toggle_player(on_move)

def toggle_player(on_move):
  if on_move == 'x':
      return 'o'
  else:
      return 'x'

def get_move_for(token, board):
    # pass in board so that we can validate the move entered
    move_str = input('Enter move for ' + token + ': ')
    x, y = move_str.split(' ')
    return int(x), int(y)

def make_board():
    board = []
    for i in range(3):
        row = [' ', ' ', ' ']
        board.append(row)
    return board

# -------------------------------
# Day 24, Opening Exercise
# -------------------------------

def legal_moves(board):
    legal_moves = []
    for row in range(3):
        for col in range(3):
            if not is_occupied(board, row, col):
                legal_moves.append( (row, col) )
    return legal_moves

from random import randint

def get_move_for(token, board):
    if token == 'o':
        # human player
        move_str = input('Enter move for ' + token + ': ')
        x, y = move_str.split(' ')
        return int(x), int(y)
    else:
        # computer player
        moves = legal_moves(board)
        pos   = randint( 0, len(moves)-1 )
        x, y  = moves[pos]                            # can return this
        print('Random move for ' + token + ':', x, y) # but added this
        return x, y

# -------------------------------
# MAIN PROGRAM
# -------------------------------

play()

# -------------------------------
# TEST DATA AND TEST CASES
# -------------------------------

board_1 = [ [' ', ' ', 'x'],  \
            ['o', ' ', 'x'],  \
            [' ', ' ', 'o'] ]

board_2 = [ [' ', ' ', 'x'],  \
            ['o', 'o', 'x'],  \
            [' ', ' ', 'x'] ]

board_3 = [ ['o', ' ', 'x'],  \
            ['x', 'o', 'x'],  \
            [' ', ' ', 'o'] ]

board_4 = [ ['o', ' ', 'x'],  \
            ['x', 'x', 'x'],  \
            [' ', 'o', 'o'] ]

# display( board_1 )
# print()
# display( board_2 )
# print()
# display( board_3 )
# print()

# print(False, is_occupied(board_1, 0, 1))
# print(True, is_occupied(board_2, 2, 2))

# print(True,  is_a_win_for( 'x', board_4 ))
# print(False, is_a_win_for( 'o', board_4 ))
# print(True,  is_a_win_for( 'x', board_2 ))
# print(False, is_a_win_for( 'o', board_2 ))

# print(True,  is_a_win_for( 'o', board_3 ))
# print(False, is_a_win_for( 'x', board_3 ))

# print( legal_moves(board_1) )
# print( legal_moves(board_2) )
# print( legal_moves(board_3) )
# print( legal_moves(board_4) )

